commit ee8645869cd254d7a81bc745c5776fd91b907067
Author: freddy77 <freddy77>
Date:   Wed Dec 16 13:06:30 2009 +0000

    Simplified yesterday path for Windows compile

diff --git a/ChangeLog b/ChangeLog
index 2b247a0..77b4434 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Wed Dec 16 14:06:17 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tdsodbc.h src/odbc/connectparams.c src/odbc/error.c:
+	* src/odbc/odbc.c:
+	- Simplified yesterday path for Windows compile
+
 Wed Dec 16 13:54:52 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/convert_tds2sql.c: Fix conversion for uni(var)char
 
@@ -2001,4 +2006,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2910 2009/12/16 12:55:21 freddy77 Exp $
+$Id: ChangeLog,v 1.2911 2009/12/16 13:06:30 freddy77 Exp $
diff --git a/include/tdsodbc.h b/include/tdsodbc.h
index 231008d..53a7db9 100644
--- a/include/tdsodbc.h
+++ b/include/tdsodbc.h
@@ -66,7 +66,7 @@ extern "C"
 #endif
 #endif
 
-/* $Id: tdsodbc.h,v 1.114 2009/12/15 09:53:27 freddy77 Exp $ */
+/* $Id: tdsodbc.h,v 1.115 2009/12/16 13:06:30 freddy77 Exp $ */
 
 #if defined(__GNUC__) && __GNUC__ >= 4
 #pragma GCC visibility push(hidden)
@@ -91,12 +91,14 @@ struct _sql_error
 
 struct _sql_errors
 {
-	SQLRETURN lastrc;
-	int num_errors;
 	struct _sql_error *errs;
+	int num_errors;
+	SQLRETURN lastrc;
 	char ranked;
 };
 
+typedef struct _sql_errors TDS_ERRS;
+
 #if ENABLE_EXTRA_CHECKS
 void odbc_check_struct_extra(void *p);
 
@@ -433,8 +435,8 @@ BOOL get_login_info(HWND hwndParent, TDSCONNECTION * connection);
  * \param connection          structure where to store informations
  * \return 0 if error, 1 otherwise
  */
-int odbc_parse_connect_string(TDS_DBC *dbc, const char *connect_string, const char *connect_string_end, TDSCONNECTION * connection);
-int odbc_get_dsn_info(TDS_DBC *dbc, const char *DSN, TDSCONNECTION * connection);
+int odbc_parse_connect_string(TDS_ERRS *errs, const char *connect_string, const char *connect_string_end, TDSCONNECTION * connection);
+int odbc_get_dsn_info(TDS_ERRS *errs, const char *DSN, TDSCONNECTION * connection);
 
 /*
  * convert_tds2sql.c
diff --git a/src/odbc/connectparams.c b/src/odbc/connectparams.c
index c9fbc49..631d379 100644
--- a/src/odbc/connectparams.c
+++ b/src/odbc/connectparams.c
@@ -37,7 +37,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: connectparams.c,v 1.80 2009/12/15 11:46:39 freddy77 Exp $");
+TDS_RCSID(var, "$Id: connectparams.c,v 1.81 2009/12/16 13:06:30 freddy77 Exp $");
 
 static const char odbc_param_Servername[] = "Servername";
 static const char odbc_param_Address[] = "Address";
@@ -111,15 +111,14 @@ static int SQLGetPrivateProfileString(LPCSTR pszSection, LPCSTR pszEntry, LPCSTR
 #endif
 
 static int
-parse_server(TDS_DBC *dbc, char *server, TDSCONNECTION * connection)
+parse_server(TDS_ERRS *errs, char *server, TDSCONNECTION * connection)
 {
 	char ip[64];
 	char *p = (char *) strchr(server, '\\');
 
 	if (p) {
 		if (!tds_dstr_copy(&connection->instance_name, p+1)) {
-			if (dbc)
-				odbc_errs_add(&dbc->errs, "HY001", NULL);
+			odbc_errs_add(errs, "HY001", NULL);
 			return 0;
 		}
 		*p = 0;
@@ -127,8 +126,7 @@ parse_server(TDS_DBC *dbc, char *server, TDSCONNECTION * connection)
 
 	tds_lookup_host(server, ip);
 	if (!tds_dstr_copy(&connection->ip_addr, ip)) {
-		if (dbc)
-			odbc_errs_add(&dbc->errs, "HY001", NULL);
+		odbc_errs_add(errs, "HY001", NULL);
 		return 0;
 	}
 
@@ -149,7 +147,7 @@ myGetPrivateProfileString(const char *DSN, const char *key, char *buf)
  * @return 1 if success 0 otherwhise
  */
 int
-odbc_get_dsn_info(TDS_DBC *dbc, const char *DSN, TDSCONNECTION * connection)
+odbc_get_dsn_info(TDS_ERRS *errs, const char *DSN, TDSCONNECTION * connection)
 {
 	char tmp[FILENAME_MAX];
 	int freetds_conf_less = 1;
@@ -160,13 +158,11 @@ odbc_get_dsn_info(TDS_DBC *dbc, const char *DSN, TDSCONNECTION * connection)
 		tds_dstr_copy(&connection->server_name, tmp);
 		tds_read_conf_file(connection, tmp);
 		if (myGetPrivateProfileString(DSN, odbc_param_Server, tmp) > 0) {
-			if (dbc)
-				odbc_errs_add(&dbc->errs, "HY000", "You cannot specify both SERVERNAME and SERVER");
+			odbc_errs_add(errs, "HY000", "You cannot specify both SERVERNAME and SERVER");
 			return 0;
 		}
 		if (myGetPrivateProfileString(DSN, odbc_param_Address, tmp) > 0) {
-			if (dbc)
-				odbc_errs_add(&dbc->errs, "HY000", "You cannot specify both SERVERNAME and ADDRESS");
+			odbc_errs_add(errs, "HY000", "You cannot specify both SERVERNAME and ADDRESS");
 			return 0;
 		}
 	}
@@ -184,7 +180,7 @@ odbc_get_dsn_info(TDS_DBC *dbc, const char *DSN, TDSCONNECTION * connection)
 		if (myGetPrivateProfileString(DSN, odbc_param_Server, tmp) > 0) {
 			tds_dstr_copy(&connection->server_name, tmp);
 			if (!address_specified) {
-				if (!parse_server(dbc, tmp, connection))
+				if (!parse_server(errs, tmp, connection))
 					return 0;
 			}
 		}
@@ -235,7 +231,7 @@ odbc_get_dsn_info(TDS_DBC *dbc, const char *DSN, TDSCONNECTION * connection)
  * @return 1 if success 0 otherwhise
  */
 int
-odbc_parse_connect_string(TDS_DBC *dbc, const char *connect_string, const char *connect_string_end, TDSCONNECTION * connection)
+odbc_parse_connect_string(TDS_ERRS *errs, const char *connect_string, const char *connect_string_end, TDSCONNECTION * connection)
 {
 	const char *p, *end;
 	DSTR *dest_s, value;
@@ -285,8 +281,7 @@ odbc_parse_connect_string(TDS_DBC *dbc, const char *connect_string, const char *
 			end = connect_string_end;
 
 		if (!tds_dstr_copyn(&value, p, end - p)) {
-			if (dbc)
-				odbc_errs_add(&dbc->errs, "HY001", NULL);
+			odbc_errs_add(errs, "HY001", NULL);
 			return 0;
 		}
 
@@ -294,14 +289,13 @@ odbc_parse_connect_string(TDS_DBC *dbc, const char *connect_string, const char *
 			/* error if servername or DSN specified */
 			if ((cfgs & (CFG_DSN|CFG_SERVERNAME)) != 0) {
 				tds_dstr_free(&value);
-				if (dbc)
-					odbc_errs_add(&dbc->errs, "HY000", "Only one between SERVER, SERVERNAME and DSN can be specified");
+				odbc_errs_add(errs, "HY000", "Only one between SERVER, SERVERNAME and DSN can be specified");
 				return 0;
 			}
 			if (!cfgs) {
 				dest_s = &connection->server_name;
 				/* not that safe cast but works -- freddy77 */
-				if (!parse_server(dbc, (char *) tds_dstr_cstr(&value), connection)) {
+				if (!parse_server(errs, (char *) tds_dstr_cstr(&value), connection)) {
 					tds_dstr_free(&value);
 					return 0;
 				}
@@ -310,8 +304,7 @@ odbc_parse_connect_string(TDS_DBC *dbc, const char *connect_string, const char *
 		} else if (strcasecmp(option, "SERVERNAME") == 0) {
 			if ((cfgs & (CFG_DSN|CFG_SERVER)) != 0) {
 				tds_dstr_free(&value);
-				if (dbc)
-					odbc_errs_add(&dbc->errs, "HY000", "Only one between SERVER, SERVERNAME and DSN can be specified");
+				odbc_errs_add(errs, "HY000", "Only one between SERVER, SERVERNAME and DSN can be specified");
 				return 0;
 			}
 			if (!cfgs) {
@@ -324,12 +317,11 @@ odbc_parse_connect_string(TDS_DBC *dbc, const char *connect_string, const char *
 		} else if (strcasecmp(option, "DSN") == 0) {
 			if ((cfgs & (CFG_SERVER|CFG_SERVERNAME)) != 0) {
 				tds_dstr_free(&value);
-				if (dbc)
-					odbc_errs_add(&dbc->errs, "HY000", "Only one between SERVER, SERVERNAME and DSN can be specified");
+				odbc_errs_add(errs, "HY000", "Only one between SERVER, SERVERNAME and DSN can be specified");
 				return 0;
 			}
 			if (!cfgs) {
-				if (!odbc_get_dsn_info(dbc, tds_dstr_cstr(&value), connection)) {
+				if (!odbc_get_dsn_info(errs, tds_dstr_cstr(&value), connection)) {
 					tds_dstr_free(&value);
 					return 0;
 				}
diff --git a/src/odbc/error.c b/src/odbc/error.c
index cdae3fc..e5eaa09 100644
--- a/src/odbc/error.c
+++ b/src/odbc/error.c
@@ -44,7 +44,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: error.c,v 1.57 2008/08/18 13:31:27 freddy77 Exp $");
+TDS_RCSID(var, "$Id: error.c,v 1.58 2009/12/16 13:06:30 freddy77 Exp $");
 
 static void odbc_errs_pop(struct _sql_errors *errs);
 static const char *odbc_get_msg(const char *sqlstate);
@@ -384,10 +384,13 @@ void
 odbc_errs_add(struct _sql_errors *errs, const char *sqlstate, const char *msg)
 {
 	struct _sql_error *p;
-	int n = errs->num_errors;
+	int n;
 
 	assert(sqlstate);
+	if (!errs)
+		return;
 
+	n = errs->num_errors;
 	if (errs->errs)
 		p = (struct _sql_error *) realloc(errs->errs, sizeof(struct _sql_error) * (n + 1));
 	else
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index de28180..40618a0 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.519 2009/12/15 11:23:47 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.520 2009/12/16 13:06:30 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -447,7 +447,7 @@ SQLDriverConnect(SQLHDBC hdbc, SQLHWND hwnd, SQLCHAR FAR * szConnStrIn, SQLSMALL
 		tds_dstr_dup(&connection->database, &dbc->attr.current_catalog);
 
 	/* parse the DSN string */
-	odbc_parse_connect_string(dbc, (const char *) szConnStrIn, (const char *) szConnStrIn + conlen, connection);
+	odbc_parse_connect_string(&dbc->errs, (const char *) szConnStrIn, (const char *) szConnStrIn + conlen, connection);
 
 	/* add login info */
 	if (hwnd) {
@@ -1717,7 +1717,7 @@ SQLConnect(SQLHDBC hdbc, SQLCHAR FAR * szDSN, SQLSMALLINT cbDSN, SQLCHAR FAR * s
 		tds_dstr_copy(&dbc->dsn, "DEFAULT");
 
 
-	if (!odbc_get_dsn_info(dbc, tds_dstr_cstr(&dbc->dsn), connection)) {
+	if (!odbc_get_dsn_info(&dbc->errs, tds_dstr_cstr(&dbc->dsn), connection)) {
 		tds_free_connection(connection);
 		ODBC_RETURN(dbc, SQL_ERROR);
 	}

